/***************************************************************
 ՓN玁(http://www.picfun.com/)JĂPICp
 uUSBN960p@{foCXvOvɊÂāA
 啝ɉCāA Kane BeBe H8/3069FɈڐAĂ܂B
 
 PC̃foCXhCo͔삳(http://www.otto.to/~kasiwano/)
  ėpUSBfoCXhCogpĂ܂B
***************************************************************/
//////////////////////////////////////////////////
//  
//  for USBN960x USB program
//  function
//      pipe  IN 3  OUT 3
//
//////////////////////////////////////////////////

#ifdef _USBN9604_FOR_TOPPERS_
//	USBN9604 driver for TOPPERS
#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <sys_config.h>
#include <usbn9604_sys_config.h>
#include "if_usbn9604.h"

#else
//	USBN9604 driver for MES
#include	<mes2.h>
#include	<string.h>
#include <regdef.h>

#define		IRQn				4
#define		IRQVector(n)		(12 + n)
#define		low(n)				ISCR &= (-1^(1 << n))

#define		USBN9604_INIT_TASK	0
#define		USBN9604_BASE_ADDRESS	0x800004
#define		VP					volatile unsigned char *
inline void sil_wrb_mem(VP adr, char data){ *adr = data; }
inline unsigned char sil_reb_mem(VP adr){ return *adr;}
#define		DTQ_USBN9604_INPUT	0
#define		LOG_NOTICE	0
#define		E_OK	0
typedef	int VP_INT;
#define		dly_tsk	sleep
#define		ipsnd_dtq(a, b)	{b;}
#define		syslog(a, b)	{printf(b); printf("\r");}
#define		usbn9604_init_task(a)	main()
#define		usbn9604_dis_inter()	IER &= (-1^(1 << IRQn))
#define		usbn9604_ena_inter()	IER |= (1 << IRQn)
void	if_usbn9604_handler (void);
int		*getFIFO();
void	global_var_init();
void	init_usbn();
#pragma interrupt
void usb_isr(void)
{
	load_segment(IRQVector(IRQn));
	if_usbn9604_handler();
}
void	usbn9604_inter_init(){
	set_handler(IRQVector(IRQn), usb_isr);
	low(IRQn);
	usbn9604_ena_inter();
}
int	rcv_dtq(int a, VP_INT* b){
	while((*b = (VP_INT)getFIFO()) == NULL){
		dly_tsk(10);
	}
	return E_OK;
}
#endif

#include    "usbn960x.h"
#include    "usbdef40.h"
               
typedef struct
{
	char	EPn;
	char	toggle;
	char	*buf;
	short	len;
} USBR;

typedef struct
{
	const	char	RXD;
	const	char	RXS;
	const	char	RXC;

	const	char	TXD;
	const	char	TXS;
	const	char	TXC;
} USB_READ;

typedef struct
{
	char	TXD;
	char	TXS;
	char	TXC;

	char	toggle;
	short	len;
	const	char	*buf;
} USBSEND;

#define		USBN960xR			(USBN9604_BASE_ADDRESS + 2)
#define		USBN960xD			USBN9604_BASE_ADDRESS

#define		USB_CLKDIV			0x04				// CLKOUT = 48MHz/4 = 12MHz
#define		bit_clear(n, bit)	n &= ~(1<<bit)
#define		bit_set(n, bit)		n |= (1<<bit)
#define		bit_test(n, bit)	n & (1<<bit)

#define	FIFO_LENGTH	100
#define	LOCKMEM(size)		USBRbufferPoint += size

static	char soutHexBuff[64*4];

//////// USB global var@//////////
#define	USB_CONFIG	usbSendArray->TXD
#define	STALLD		usbSendArray->TXS
#define	SETADDR		usbSendArray->TXC

char USBRbuffer[FIFO_LENGTH*64];
char *USBRbufferPoint;
USBR USBR_FIFO[FIFO_LENGTH], *FIFO_start, *FIFO_end;

const char LANGUAGEINDEX[] = {4,3,9,4};
char EP0OutBuf[64];
#define	add2EP0OutBuf(adr, c)	EP0OutBuf[adr] = c
USB_READ usbReadArray[] = {
	{RXD0, RXS0, RXC0,    0,    0,    0},
	{RXD1, RXS1, RXC1, TXD1, TXS1, TXC1},
	{RXD2, RXS2, RXC2, TXD2, TXS2, TXC2},
	{RXD3, RXS3, RXC3, TXD3, TXS3, TXC3}
};
USBSEND usbSendArray[] = {
	{0, 0, 0, 0, 0, NULL},
	{TXD1, TXS1, TXC1, 0, 0, NULL},
	{TXD2, TXS2, TXC2, 0, 0, NULL},
	{TXD3, TXS3, TXC3, 0, 0, NULL}
};

void global_var_init(){
	short i, n;
	FIFO_start = FIFO_end = USBR_FIFO;
	USBRbufferPoint = USBRbuffer;

	n = sizeof(usbSendArray) / sizeof(USBSEND);
	for(i = 0; i < n; i ++){
		usbSendArray[i].TXD = usbReadArray[i].TXD;
		usbSendArray[i].TXS = usbReadArray[i].TXS;
		usbSendArray[i].TXC = usbReadArray[i].TXC;

		usbSendArray[i].toggle = 0;
		usbSendArray[i].len = 0;
		usbSendArray[i].buf = NULL;
	}
}

void byte2Hex(char c, char *p){
	char lh, ll;
	lh = (c >> 4) & 0x0f;
	ll = c & 0x0f;
	if(lh < 10) *p ++ = '0' + lh;
	else *p ++ = 'A' + lh - 10;
	if(ll < 10) *p ++ = '0' + ll;
	else *p ++ = 'A' + ll - 10;
}

void printBytes(char *p, int len, char* outBuf){
	int i, n;
	if(p && len) {
		for(n = i = 0; i < len; i ++){
			byte2Hex(*p++, outBuf);
			outBuf += 2;
			n ++;
			if(n >= 16){
				*outBuf++ = '\r';
				n = 0;
			}
			else *outBuf++ = ' ';
		}
		outBuf --;
	}
	*outBuf = 0;
}


int	*getFIFO(){
	USBR *p;
	if(FIFO_start == FIFO_end) p = NULL;
	else{
		p = FIFO_start ++; 
		if(FIFO_start >= USBR_FIFO + FIFO_LENGTH)
			FIFO_start = USBR_FIFO;
	}
	return (int *)p;
}

USBR	*saveFIFO(char EPn, char toggle, char *buf, short len){
	USBR *p;
	p = FIFO_end;
	FIFO_end->EPn = EPn;
	FIFO_end->toggle = toggle;
	FIFO_end->buf = buf;
	FIFO_end->len = len;
	FIFO_end ++;
	if(FIFO_end >= USBR_FIFO + FIFO_LENGTH)
		FIFO_end = USBR_FIFO;
	return p;
}

char *getBufferPoint(){
	USBRbufferPoint = (char *)((int)(USBRbufferPoint + 3) & ~3);
	if(USBRbuffer + sizeof(USBRbuffer) < USBRbufferPoint + 64)
		USBRbufferPoint = USBRbuffer;
	return USBRbufferPoint;
}


inline unsigned char usbn9604Read(char adr)
{
	sil_wrb_mem((VP)USBN960xR, adr);
	return sil_reb_mem((VP)USBN960xD);
}

inline void usbn9604Write(char adr,char data)
{
	sil_wrb_mem((VP)USBN960xR, adr);
	sil_wrb_mem((VP)USBN960xD, data);
}

short usbn9604BufRead(char adr, char *buf, char size)
{
	char *buffk, addrs, rcnt;
	buffk = buf;
	addrs = adr + 1;
	while((size > 0) && (rcnt = usbn9604Read(addrs) & 0xf) > 0){
		if(rcnt > size) rcnt = size;
		size -= rcnt;
		sil_wrb_mem((VP)USBN960xR, adr);
		while(rcnt--) *buffk++ = sil_reb_mem((VP)USBN960xD);
	}
	return(buffk - buf);
}

short usbn9604BufWrite(char adr, const char *buf, char size)
{
	const char *buffk;
	char addrs, rcnt;
	buffk = buf;
	addrs = adr + 1;
	while((size > 0) && (rcnt = usbn9604Read(addrs) & 0x1f) > 0){
		if(rcnt > size) rcnt = size;
		size -= rcnt;
		sil_wrb_mem((VP)USBN960xR, adr);
		while(rcnt--) sil_wrb_mem((VP)USBN960xD, *buffk++);
	}
	return(buffk - buf);
}

void usbn9604_bitset(char UADR)
{
	char STAL;
	STAL = usbn9604Read(UADR);
	usbn9604Write(UADR,(STAL | 0x80));
}

void usbn9604_bitclr(char UADR)
{
	char     STAL;
	STAL = usbn9604Read(UADR);
	usbn9604Write(UADR, (STAL & 0x7F));
}

/* Receive from endpoint n (RXFIFOn) */
void usbn960x_rx_EPn(char EPn)
{
	USB_READ *usbr;
    char *buf, rxstat;
    short size;
    usbr = usbReadArray + EPn;
    rxstat = usbn9604Read(usbr->RXS);

    if(!(rxstat & (SETUP_RX | RX_ERR)))
	{
	    buf = getBufferPoint();
    	size = usbn9604BufRead(usbr->RXD,buf,64);
    	LOCKMEM(size);
	    ipsnd_dtq(DTQ_USBN9604_INPUT, (VP_INT)saveFIFO(EPn, rxstat & RX_TOGL, buf, size));
	}

	/* Execute RxData processor */
//	BOMS_bulkOut() ;

	/* prepare for receiving the next data in EP2 FIFO */
    usbn9604Write(usbr->RXC,FLUSH);
    usbn9604Write(usbr->RXC,RX_EN);                 //RX1 can receive

	return ;
}

/* Write contents in bbuf_tx_EP1 to endpoint1 FIFO */
/* Return value = 1 when no more data to send in bbuf_tx_EP1 */
/* 				= 0 when some data remain */
short USBN960x_wrFIFO_EPn(char EPn)
{
	short i;

	USBSEND *p;
	p = usbSendArray + EPn;

	if(!p->len) return 1 ;

	usbn9604Write(p->TXC,FLUSH);

	i = usbn9604BufWrite(p->TXD, p->buf, p->len);
	p->buf -= i;
	p->len -= i;

	/* Transmit enable */
	usbn9604Write(p->TXC,p->toggle+TX_EN+TX_LAST);

	return 0 ;
}

void usbn960x_tx_EPn(char EPn)
{
    char txstat;
	USBSEND *p;
	p = usbSendArray + EPn;

    txstat = usbn9604Read(p->TXS);

	if(txstat & TX_DONE)	/* Transmission is done */
	{
		if(txstat & ACK_STAT)	/* ACK has sent from HOST */
		{
			/* invert TOGGLE bit because ACK has been received */
			p->toggle ^= TX_TOGL;
			/* write data to EP1 FIFO */
//			if(USBN960x_wrFIFO_EPn(EPn))	/* If no more data to send */
//				BOMS_bulkIn() ;
			USBN960x_wrFIFO_EPn(EPn);
		}
		else						/* ACK is not received */
		{
			/* Re-transmit the last data */
			usbn9604Write(p->TXC,p->toggle+TX_EN+TX_LAST+IGN_IN);
		}
	}

	return ;
}


void	sendMsg2EPn(USBR *usb){
	USBSEND *p;
	usbn9604_dis_inter();
	p = usbSendArray + usb->EPn;

	p->buf = usb->buf;
	p->len = usb->len;

	USBN960x_wrFIFO_EPn(usb->EPn);
	usbn9604_ena_inter();
}


///////////////////////////////////////////////////
//////// USBN960x event  ////////////
///////////////////////////////////////////////////
/////@NAK event@///////
inline void  nak_evnt(void)
{
    char  evntnak;

    evntnak = usbn9604Read(NAKEV);
    if(evntnak & NAK_O0)                                //OUT endpoint 0
	{
    	if(usbSendArray->buf)
	    {
    	    usbSendArray->buf = NULL;
        	usbn9604Write(TXC0,FLUSH);
	        usbn9604Write(RXC0,RX_EN);
    	}
	}
}

////// ALT event ////////
inline void  alt_evnt(void)
{
    char  evntalt;

    evntalt = usbn9604Read(ALTEV);
//	ipsnd_dtq(DTQ_USBN9604_INPUT, (VP_INT)saveFIFO(8, evntalt, NULL, 0));

    if(evntalt & RESET_A)                       //RESET?
    {
	    global_var_init();
        usbn9604Write(NFSR,RST_ST);        //enter to reset node
        usbn9604Write(FAR,AD_EN+0);        //set default address 0
        usbn9604Write(EPC0,0);             //enable EP0 only
        usbn9604Write(TXC0,FLUSH);         //disable TX
        usbn9604Write(RXC0,RX_EN);         //enable EP0 RX
        usbn9604Write(ALTMSK,SD3);
        usbn9604Write(NFSR,OPR_ST);        //go operational
    }
    else if(evntalt & SD3)               //SUSPEND?
	{
		usbn9604Write(ALTMSK,RESUME_A+RESET_A);    //set ALTMSK RESET and RESUME
		usbn9604Write(NFSR,SUS_ST);                //SUSPEND
	}
	else if(evntalt & RESUME_A)                  //RESUME?
	{
		usbn9604Write(ALTMSK,SD3+RESET_A);     
		usbn9604Write(NFSR,OPR_ST);
	}
}


//////// Send Descriptor Function //////////
void USBN960x_wrFIFO_EP0(void)
{
	short i;
	usbn9604Write(TXC0,FLUSH);             //flush TX0
	if(usbSendArray->buf && usbSendArray->len > 0){
		i = usbn9604BufWrite(TXD0, usbSendArray->buf, usbSendArray->len);
		usbSendArray->len -= i;
		usbSendArray->buf += i;
	}
	usbn9604Write(TXC0,(usbSendArray->toggle+TX_EN));   //always DATA1
}

void	sendString2UTF16(const char *buf){
	char *outBuf = EP0OutBuf + 2;
	while(*buf) {*outBuf ++ = *buf ++; *outBuf ++ = 0;}
	EP0OutBuf[1] = 3;
	EP0OutBuf[0] = outBuf - EP0OutBuf;
	usbSendArray->buf = EP0OutBuf;
	usbSendArray->len = EP0OutBuf[0];
}

///////////  Send String Data //////////////
inline void sendstring(char *buf)
{
     switch(buf[2])                  //get lower of wValue
    {
        case 0: {                       //Language String
            usbSendArray->buf = LANGUAGEINDEX;
            usbSendArray->len = sizeof(LANGUAGEINDEX);
            break; }
        case 1: {                       //Manufacturing String
        	sendString2UTF16(MFG_STR);
            break;}
        case 2: {                       //Product String
        	sendString2UTF16(PID_STR);
            break;  }
        case 3:  {                      //Serial Number String
        	sendString2UTF16(NBR_STR);
            break;  }
        case 4: {                       //Configuration Stirng
        	sendString2UTF16(CFG_STR);
            break;  }
        case 5: {                       //Inteface String
        	sendString2UTF16(INT_STR);
            break;      }
        default:    {
            usbSendArray->buf = NULL;
            usbSendArray->len = 0;
            break;  }
    }
}

///////// Get Descriptor Process /////////
inline void getdescriptor(char *buf)
{
    switch(buf[3])               //get upper of wValue
    {
        case DEVICE:                        //1
            usbSendArray->buf = DESC + DEV_DESC_OFS;
            usbSendArray->len = DEV_LENGTH;
            break;
        case CONFIGURATION:                 //2
            usbSendArray->buf = DESC + CFG_DESC_OFS;
            usbSendArray->len = CFG_DESC_SIZE;
            break;
        case INTERFACE:                     //4
            usbSendArray->buf = DESC + IF_DESC_OFS;
            usbSendArray->len = INT_LENGTH;
            break;
        case XSTRING:                       //3
            sendstring(buf);
            break;
        default: 
            usbSendArray->buf = DESC;
            usbSendArray->len=0;
            break;
    }
    if(buf[7] == 0)                      //Upper of wLength
    {
        if (usbSendArray->len > buf[6])          //lower of wLength
            usbSendArray->len = buf[6];
    }
}

///////// Clear Feature Process ///////
inline void clrfeature(char *buf)
{
    switch(buf[0] & 0x03)        //get bmRequest check D I E
    {
        case 0: break;      //Device
        case 1: break;      //Interface
        case 2:             //Endpoint
        {
            switch(buf[4] & 0x0F)    //get lower of wIndex
            {
                case 0: usbn9604_bitclr(EPC0); bit_clear(STALLD,0); break;
                case 1: usbn9604_bitclr(EPC1); bit_clear(STALLD,1); break;
                case 2: usbn9604_bitclr(EPC2); bit_clear(STALLD,2); break;
                case 3: usbn9604_bitclr(EPC3); bit_clear(STALLD,3); break;
                case 4: usbn9604_bitclr(EPC4); bit_clear(STALLD,4); break;
                case 5: usbn9604_bitclr(EPC5); bit_clear(STALLD,5); break;
                case 6: usbn9604_bitclr(EPC6); bit_clear(STALLD,6); break;
                default: break;
            }
            break;
        }
        default: break;         //undefined case
    }
}

////////  Get Status Process  ///////////
inline void getstatus(char *buf)
{
	short index;
	index = 0;
    switch (buf[0] & 0x03)               //get bmRequest D I E
    {
        case 0: add2EP0OutBuf(index++,1); break;  //device self powered
        case 1: add2EP0OutBuf(index++,0); break;  //Interface 00
        case 2:                             //Endopoint  
            {
            if(bit_test(STALLD,(buf[4] & 0x0F))) //test lower of wIndex
                add2EP0OutBuf(index++,1);         //stall
            else
                add2EP0OutBuf(index++,0);         //not stall
            break;
            }
        default: add2EP0OutBuf(index++,0); break;
    }
    add2EP0OutBuf(index++,0);                 /*second byte is reserved */   
	usbSendArray->buf = EP0OutBuf;
	usbSendArray->len = index;
}


///////////// Set Configuration Process /////////////
inline void setconfiguration(char *buf)
{
    USB_CONFIG = buf[2];             //get lower of wValue
    if (USB_CONFIG != 0)                //check configuration #   
    {
        STALLD = 0;                     /*nothing stalled         */
        
        usbn9604Write(TXC1,FLUSH);         /*flush  TX1 and disable  */   
        usbn9604Write(EPC1,EP_EN+01);      /*enable EP1 at adr 1     */

        usbn9604Write(RXC1,FLUSH);         /*flush  RX1 and disable  */ 
        usbn9604Write(EPC2,EP_EN+02);      /*enable EP2 at adr 2     */   
        usbn9604Write(RXC1,RX_EN);         /*enable RX1              */     

        usbn9604Write(TXC2,FLUSH);         /*flush  TX2 and disable  */   
        usbn9604Write(EPC3,EP_EN+03);      /*enable EP3 at adr 3     */
        
        usbn9604Write(RXC2,FLUSH);         /*flush  RX2 and disable  */ 
        usbn9604Write(EPC4,EP_EN+04);      /*enable EP4 at adr 4     */   
        usbn9604Write(RXC2,RX_EN);         /*enable RX2              */   

        usbn9604Write(TXC3,FLUSH);         /*flush  TX3 and disable  */ 
        usbn9604Write(EPC5,EP_EN+05);      /*enable EP5 at adr 5     */   
 
        usbn9604Write(RXC3,FLUSH);         /*flush  RX3 and disable  */ 
        usbn9604Write(EPC6,EP_EN+06);      /*enable EP6 at adr 6     */   
        usbn9604Write(RXC3,RX_EN);         /*enable RX3              */     
    }
    else                                /*unconfigure the device  */
    {
        usbn9604Write(EPC1,0);             /*disable EP1             */
        usbn9604Write(EPC2,0);             /*disable EP2             */   
        usbn9604Write(EPC3,0);             /*disable EP3             */
        usbn9604Write(EPC4,0);             /*disable EP4             */
        usbn9604Write(EPC5,0);             /*disable EP5             */
        usbn9604Write(EPC6,0);             /*disable EP6             */
    }
}

////////////////  Set Feature Process  //////////////////
inline void setfeature(char *buf)
{
    switch (buf[0] & 0x03)           //get bmRequestType
    {
        case 0: break;                  //DEVICE
        case 1: break;                  //INTERFACE
        case 2:                         //ENDPOINT
        {
            switch (buf[4] & 0x0F)     //get lower of wIndex
            {
                case 0: usbn9604_bitset(EPC0);bit_set(STALLD,0); break;
                case 1: usbn9604_bitset(EPC1);bit_set(STALLD,1); break;
                case 2: usbn9604_bitset(EPC2);bit_set(STALLD,2); break;
                case 3: usbn9604_bitset(EPC3);bit_set(STALLD,3); break;
                case 4: usbn9604_bitset(EPC4);bit_set(STALLD,4); break;
                case 5: usbn9604_bitset(EPC5);bit_set(STALLD,5); break;
                case 6: usbn9604_bitset(EPC6);bit_set(STALLD,6); break;
                default:break;
            }
            break;
        }
        default:  break;
    }
}

//////////  EP0(FIFO0)  RX Event Process  /////////
inline void  usbn960x_rx_EP0(void)
{
    short size;
    char *buf, rxstat;

    rxstat = usbn9604Read(RXS0);
    if(rxstat & SETUP_RX)               //SETUP?
    {
	    buf = getBufferPoint();
    	size = usbn9604BufRead(RXD0,buf,64);
    	LOCKMEM(size);
		ipsnd_dtq(DTQ_USBN9604_INPUT, (VP_INT)saveFIFO(0, rxstat & RX_TOGL, buf, size));

        /////////@SETUPJn@/////////////
        usbn9604Write(RXC0,FLUSH);         //flush RX0
        usbn9604_bitclr(EPC0);
        switch(*buf & 0x60)        //standard Request?
        {
        case 0:		//Standard USB setup
            switch(buf[1])           //get bRequest kind of Function
            {
                case GET_DESCRIPTOR:            //6 
                    getdescriptor(buf);
                    break;  
                case CLEAR_FEATURE:             //1
                    clrfeature(buf);
                    break;
                case GET_CONFIGURATION:         //8
                    add2EP0OutBuf(0,USB_CONFIG);
					usbSendArray->buf = EP0OutBuf;
					usbSendArray->len = 1;
                    break;
                case GET_STATUS:                //0
                    getstatus(buf);
                    break;
                case GET_INTERFACE:             //10
                    add2EP0OutBuf(0,0);
					usbSendArray->buf = EP0OutBuf;
					usbSendArray->len = 1;
                    break;
                case SET_ADDRESS:               //5
					SETADDR = buf[2] + AD_EN;
                    break;
                case SET_CONFIGURATION:         //9
                    setconfiguration(buf);
                    break;
                case SET_FEATURE:               //3
                    setfeature(buf); 
                    break;
                case SET_INTERFACE:             //11
                    if(buf[2])
                        {usbn9604_bitset(EPC0);}
                    break;
                default: 
                    usbn9604_bitset(EPC0); 
                    break;                  //unknown
            }
            break;

		case 0x20:		//Class setup
			break;

		case 0x40:		//Vendor setup
			if(*buf & 0x80){	//Send messager to Host
			}
			else {	//Read command from Host only
			}
			break;
		
		default:
			usbn9604_bitset(EPC0);
			break;
        }
		usbSendArray->toggle = TX_TOGL;
	    USBN960x_wrFIFO_EP0();                             //send descriptor                 
    }
    ////// not SETUP@@///
    else
    {
        if(usbSendArray->buf)
        {
            usbSendArray->buf = NULL;                    //stop send
            usbn9604Write(TXC0,FLUSH);
        }
        usbn9604Write(RXC0,FLUSH);
        usbn9604Write(RXC0,RX_EN);             //RX0 can receive
    }
}

/////////////////  EP0(FIFO0) TX Event process  /////////////
inline void usbn960x_tx_EP0(void)
{
    char txstat;

    txstat = usbn9604Read(TXS0);
    if((txstat & TX_DONE) && (txstat & ACK_STAT))
    {
        if(usbSendArray->buf)                    //send DESC?
        {
			usbSendArray->toggle ^= TX_TOGL;
            USBN960x_wrFIFO_EP0();                     //send next desc block
        }
        else
        {
	        usbn9604Write(TXC0,FLUSH);             //flush TX0
            if(SETADDR != 0)
            {
                usbn9604Write(FAR,SETADDR);
                SETADDR = 0;
            }
            usbn9604Write(RXC0,RX_EN);         //RX0 can receive
        }
    }
    else
    ///////@error@/////
    {
        usbSendArray->buf = NULL;
        usbn9604Write(RXC0,RX_EN);
    }
}

///////@RX event@/////
inline void rx_evnt(void)
{
    char  evntrx;
    evntrx = usbn9604Read(RXEV);
    if(evntrx & RXFIFO0)                        //endpoint 0 case
        usbn960x_rx_EP0(); 
    else if(evntrx & RXFIFO1)                    //endpoint 2 case
		usbn960x_rx_EPn(1);
	else if(evntrx & RXFIFO2)                //endpoint 4 case
		usbn960x_rx_EPn(2);
	else if(evntrx & RXFIFO3)            //endpoint 6 case
		usbn960x_rx_EPn(3);
}

/////@TX event@//////
inline void tx_evnt(void)
{
    char  evnttx;
    evnttx = usbn9604Read(TXEV);
    if(evnttx & TXFIFO0)                        //endpoint 0 case
        usbn960x_tx_EP0();
    else if(evnttx & TXFIFO1)                    //endpoint 1 case
    	usbn960x_tx_EPn(1);
	else if(evnttx & TXFIFO2)                //endpoint 3 case
    	usbn960x_tx_EPn(2);
	else if(evnttx & TXFIFO3)            //endpoint 5 case
    	usbn960x_tx_EPn(3);
}

//////// USBN960x interrupt  ////////////
void
if_usbn9604_handler (void)
{
    char event;

    event = usbn9604Read(MAEV);

    if (event & RX_EV)              //RX?
        rx_evnt();
    else if (event & TX_EV)          //TX?
		tx_evnt();
	else if (event & NAK)         //NAK?
		nak_evnt();
	else if (event & ALT)	     //ALT?
		alt_evnt();
}

/************************************************************/
/* This subroutine initializes the 960x.                    */
/************************************************************/
void  init_usbn(void)
{
	USB_CONFIG = 0;
	STALLD = 0;

	usbn9604Write(MCNTRL,SRST+VGE);                //reset USBN
	dly_tsk(50);

	usbn9604Write(CCONF,USB_CLKDIV-1);
	usbn9604Write(FAR,AD_EN+0);                    //set default address to EP0

	usbn9604Write(EPC0,0);
	usbn9604Write(EPC1,0);
	usbn9604Write(EPC2,0);
	usbn9604Write(EPC3,0);
	usbn9604Write(EPC4,0);
	usbn9604Write(EPC5,0);
	usbn9604Write(EPC6,0);

	usbn9604Write(NAKMSK,NAK_O0);    //set NAK MASK
	usbn9604Write(TXMSK,TXFIFO0+TXFIFO1+TXFIFO2+TXFIFO3);  //set TX MASK
	usbn9604Write(RXMSK,RXFIFO0+RXFIFO1+RXFIFO2+RXFIFO3);  //set RX MASK
	usbn9604Write(ALTMSK,0xfe);           //set ALT MASK SD3+RESET_A

	usbn9604Write(MAMSK,INTR_E+RX_EV+NAK+TX_EV+ALT);
									/* MAEV reg. mask */
	usbn9604Write(TXC0,FLUSH);                     //flush disable USB TX0 
	usbn9604Write(RXC0,RX_EN);                     //enable receiver

	usbn9604Write(NFSR,OPR_ST);                    //start 
	usbn9604Write(MCNTRL,INT_L_O+NAT+VGE);         //activate node of USB
}

int usbn9604_init_task(VP_INT exinf){
	USBR *dp;
	usbn9604_dis_inter();
    global_var_init();
	init_usbn();

	syslog(LOG_NOTICE, "USBN9604 start:");

	usbn9604_inter_init();

	soutHexBuff[0] = 'E';
	soutHexBuff[1] = 'P';
	soutHexBuff[3] = ' ';
	soutHexBuff[4] = 'T';
	soutHexBuff[7] = ':';
	soutHexBuff[8] = ' ';
	while (rcv_dtq(DTQ_USBN9604_INPUT, (VP_INT*)(VP)&dp) == E_OK) {
		if(dp->EPn && dp->EPn < 4) sendMsg2EPn(dp);

		soutHexBuff[2] = dp->EPn + '0';
		byte2Hex(dp->toggle, soutHexBuff + 5);
		printBytes(dp->buf, dp->len, soutHexBuff + 9);

		syslog(LOG_NOTICE, soutHexBuff);
		dly_tsk(10);
    }
    return 0;
}

